"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const koa_router_1 = __importDefault(require("koa-router"));
const apiRouter = koa_router_1.default();
// add url-route in /controllers:
function addMapping(router, mapping, debug) {
    for (const url in mapping) {
        if (url.startsWith("GET ")) {
            const lpath = url.substring(4);
            router.get(lpath, mapping[url]);
            debug && console.log(`register URL mapping: GET ${lpath}`);
        }
        else if (url.startsWith("POST ")) {
            const lpath = url.substring(5);
            router.post(lpath, mapping[url]);
            debug && console.log(`register URL mapping: POST ${lpath}`);
        }
        else if (url.startsWith("PUT ")) {
            const lpath = url.substring(4);
            router.put(lpath, mapping[url]);
            debug && console.log(`register URL mapping: PUT ${lpath}`);
        }
        else if (url.startsWith("DELETE ")) {
            const lpath = url.substring(7);
            router.del(lpath, mapping[url]);
            debug && console.log(`register URL mapping: DELETE ${lpath}`);
        }
        else {
            console.log(`invalid URL: ${url}`);
        }
    }
}
function addControllers(router, dir, debug) {
    fs_1.default.readdirSync(path_1.default.join(__dirname, dir))
        .filter(f => {
        return f.endsWith(".js");
    })
        .forEach(f => {
        debug && console.log(`process controller: ${f}...`);
        const mapping = require(path_1.default.join(__dirname, dir, f));
        addMapping(router, mapping, debug);
    });
}
function controller(dir = "controllers", debug = false) {
    addControllers(apiRouter, dir, debug);
    return apiRouter.routes();
}
exports.controller = controller;
//# sourceMappingURL=controller.js.map